﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace XFSparkline
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(true)]
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Clicked(object sender, EventArgs e)
        {
            Random rand = new Random();
            if (List.SelectedItem != null)
            {
                List<PerformanceModel> PerformanceData = new List<PerformanceModel>()
                {
                    new PerformanceModel { Rating = rand.Next(0, 10) },
                    new PerformanceModel { Rating = rand.Next(0, 10) },
                    new PerformanceModel { Rating = rand.Next(0, 10) },
                    new PerformanceModel { Rating = rand.Next(0, 10) },
                    new PerformanceModel { Rating = rand.Next(0, 10) },
                };

                (List.SelectedItem as Model).Performance = PerformanceData;
            }
        }                                                                         
    }

    public class PerformanceModel
    {
        public double Rating { get; set; }
    }

    public class Model : BindableObject
    {
        public string Name { get; set; }

        public static readonly BindableProperty PerformanceProperty =
            BindableProperty.Create("Performance", typeof(List<PerformanceModel>), typeof(Model), null, BindingMode.Default, null, null);

        public List<PerformanceModel> Performance
        {
            get { return (List<PerformanceModel>)this.GetValue(PerformanceProperty); }
            set { this.SetValue(PerformanceProperty, value); }
        }


        //public List<PerformanceModel> Performance { get; set; }
        public Model()
        {
            Performance = new List<PerformanceModel>();
        }
    }

    public class ViewModel
    {
        public List<Model> Data { get; set; }

        public ViewModel()
        {
            Random rand = new Random();
            Data = new List<Model>();

            List<PerformanceModel> JhonPerformance = new List<PerformanceModel>()
            {
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
            };

            Data.Add(new Model { Name = "John", Performance = JhonPerformance });

            List<PerformanceModel> AntonPerformance = new List<PerformanceModel>()
            {
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
            };

            Data.Add(new Model { Name = "Anton", Performance = AntonPerformance });

            List<PerformanceModel> RichardPerformance = new List<PerformanceModel>()
            {
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
            };

            Data.Add(new Model { Name = "Richard", Performance = RichardPerformance });

            List<PerformanceModel> MarkPerformance = new List<PerformanceModel>()
            {
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
            };

            Data.Add(new Model { Name = "Mark", Performance = MarkPerformance });

            List<PerformanceModel> MichaelPerformance = new List<PerformanceModel>()
            {
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
            };

            Data.Add(new Model { Name = "Michael", Performance = MichaelPerformance });

            List<PerformanceModel> DavidPerformance = new List<PerformanceModel>()
            {
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
                new PerformanceModel { Rating = rand.Next(0, 10) },
            };

            Data.Add(new Model { Name = "David", Performance = DavidPerformance });
        }
    }
}
